

function createGUI() {

	calculateLayout();
	createRightSideSpace();
	
	var canvasSpace = {
		xtype : 'panel',
		id : 'canvas_container_panel',
		html : [
				'<div id="canvas_container" style="width:'
						+ (this.origCanvasWidth + 1) + 'px; height:'
						+ this.origCanvasHeight + 'px; ">',
				generateViewsCanvas(),
				'<canvas id="overlay" width="' + this.origCanvasWidth
						+ '" height="' + this.origCanvasHeight
						+ '" class="animClass" style="position:absolute;">',
				"Your browser doesn't support HTML5 canvas.",
				'</canvas></div>' ].join(""),
		flex : canvasFlex
	};

	Ext.getCmp('canvas-panel').setItems([canvasSpace, rightSideSpace]);
	
	for (var i in canvasViews) {
		var tempContext = document.getElementById(canvasViews[i].id).getContext('2d');
		tempContext.fillStyle = 'white';
		tempContext.fillRect(0, 0, origCanvasWidth, origCanvasHeight);
	}

	var scaleFactorLabelLeftPos = origCanvasWidth*initScale*0.75 + totalFreeSpace/2;
	if (totalFreeSpace < 0) scaleFactorLabelLeftPos = Ext.get('canvas-panel').getWidth() - viewSwitcherWidth - 110;

	Ext.getCmp('canvas_container_panel').add({ 
		xtype: 'panel', 
	    id: 'scaleFactorLabel',
	    baseCls: 'scaleFactorLabel',
	    top: origCanvasHeight*initScale*0.95,
	    left: scaleFactorLabelLeftPos
	});		
}


function calculateLayout() {

	var mainPanelWidth = Ext.get('canvas-panel').getWidth();
	var mainPanelHeight = Ext.get('canvas-panel').getHeight();
	
	initScale = mainPanelHeight / origCanvasHeight;

	scaledHeight = initScale * origCanvasHeight;
	scaledWidth = initScale * origCanvasWidth;

	viewSwitcherWidth = scaledWidth / viewSwitcherSpots;
	totalFreeSpace = mainPanelWidth - viewSwitcherWidth - scaledWidth;
	
	sideFlex = viewSwitcherWidth / mainPanelWidth;
	canvasFlex = 1 - sideFlex;
	
	initialTranslationX = (scaledWidth - origCanvasWidth + totalFreeSpace) / 2;
	initialTranslationY = (scaledHeight - origCanvasHeight) / 2;
	
	viewSwitcherInitialTranslationX = (scaledWidth / viewSwitcherSpots- origCanvasWidth) / 2;
	viewSwitcherInitialTranslationY = (scaledHeight / viewSwitcherSpots - origCanvasHeight) / 2;
}



function createRightSideSpace() {
	this.rightSideSpace = {
		xtype : 'panel',
		id : 'canvas-view-switcher',
		width: viewSwitcherWidth,
		layout : 'vbox',
		items : canvasViewSwitcherItems()
	};
}





function activateColorButton(number) {
	if (!(this.activeColorButtonNr == 0 && number == 0)) {
		var oldActiveButtonId = 'colBut' + this.activeColorButtonNr;
		var newActiveButtonId = 'colBut' + number;
		
		if (this.activeColorButtonNr != 0) { // not the eraser-button
			var oldActiveButton = Ext.getCmp(oldActiveButtonId);
			if (oldActiveButton) {
				oldActiveButton.setCls('new-color-btn');
			}
		} else { // eraser-button
			Ext.getCmp('eraser-button').setCls('drawing-button');
			this.tmpColorButtonNr = 0;
		}
	
		if (number != 0) { // not the eraser-button
			var newActiveButton = Ext.getCmp(newActiveButtonId);
			
			if (newActiveButton) {
				newActiveButton.setCls('new-color-btn-active');
				
				if (intensityLabel) {
					intensityLabel.setHtml(newActiveButton.config.label);
					intensityLabel.showBy(newActiveButton);
				}
				color = newActiveButton.config.color;
			}
		} else { // eraser-button
			intensityLabel.hide();
			this.tmpColorButtonNr = this.activeColorButtonNr;
			color = '#FFFFFF';
			Ext.getCmp('eraser-button').setCls('drawing-button-activated');
		}
		this.activeColorButtonNr = number;	

	} else if (this.tmpColorButtonNr) { //eraser is active and tapped again --> toggle
		activateColorButton(this.tmpColorButtonNr);
		this.tmpColorButtonNr = 0;
	}

}




function getAllActiveTopToolbarsHeight() {
	var totalTopHeight = 0;
	var item = Ext.Viewport;

	while (item.isContainer) {
		totalTopHeight += getTopToolbarsHeight(item);
		item = item.getActiveItem();
	}
	return totalTopHeight;
}


function getTopToolbarsHeight(item) {
	var topToolbarsHeight = 0;
	var dockedItems = item.getDockedItems();

	if (dockedItems) {
		for ( var i = 0; i < dockedItems.length; i++) {
			if (dockedItems[i].getDocked() == 'top') {
				topToolbarsHeight += Ext.get(dockedItems[i].id).getHeight();
			}
		}
	}
	return topToolbarsHeight;
}

var frontImgPath;
var backImgPath;
var leftImgPath;
var rightImgPath;
function CanvasView(id, image) {
	this.id = id;
	this.image = new Image();
	this.image.src = image;
	this.points = new Array();
	this.redoStack = new Array();
	this.previousX = 0;
	this.previousY = 0;
	this.previousS = 1;
	this.curX = 0;
	this.curY = 0;
	this.curS = 1;
}
function createCanvasViews() {
	Ext.getStore('SQ_PersonalInfo').loadNewestUserRecord(function(currentPersonalInfo) {
		if (currentPersonalInfo && currentPersonalInfo.get('sex') == 'female') { 
			frontImgPath = frontFemaleImgPath;
			backImgPath = backFemaleImgPath;
			leftImgPath = leftFemaleImgPath;
			rightImgPath = rightFemaleImgPath;
		} else {
			frontImgPath = frontMaleImgPath;
			backImgPath = backMaleImgPath;
			leftImgPath = leftMaleImgPath;
			rightImgPath = rightMaleImgPath;
		}
		canvasViews = new Array(
			new CanvasView('front-view', frontImgPath),
			new CanvasView('back-view', backImgPath),
			new CanvasView('left-view', leftImgPath),
			new CanvasView('right-view', rightImgPath));
	});
}
function getCanvasViewFromId(id) {
	var view = null;
	for ( var i = 0; i < canvasViews.length; i++) {
		if (canvasViews[i].id == id) {
			view = canvasViews[i];
			break;
		}
	}
	return view;
}
function switchViewTo(view) {
	
	this.activeCanvasView.points = this.points;
	this.activeCanvasView.redoStack = this.redoStack;
	this.activeCanvasView.curX = curX;
	this.activeCanvasView.curY = curY;
	this.activeCanvasView.curS = curScale;
	this.activeCanvasView.previousX = previousXTranslate;
	this.activeCanvasView.previousY = previousYTranslate;
	this.activeCanvasView.previousS = previousScale;
	
	clearCanvas(this.viewSwitcherOverlay);
	
	this.main.style.visibility = "hidden";
	
	setActiveView(view);
}
function setActiveView(view) {
	
	this.overlayElement = document.getElementById('overlay');
	this.overlayElement.style.background = 'url(' + view.image.src + ')';
	this.main = document.getElementById(view.id);
	this.context = main.getContext('2d');
	this.context.lineJoin = "round";
	this.context.lineCap = "round";
	
	this.viewSwitcherMain = document.getElementById(view.id + '_switcher');
	this.viewSwitcherContext = viewSwitcherMain.getContext('2d');
	this.viewSwitcherContext.lineJoin = "round";
	this.viewSwitcherContext.lineCap = "round";
	this.viewSwitcherOverlay = document.getElementById(view.id + '_switcher_overlay');
	this.viewSwitcherOverlayContext = viewSwitcherOverlay.getContext('2d');
	this.viewSwitcherOverlayContext.strokeStyle = '#1468A2';
	this.viewSwitcherOverlayContext.lineWidth = origCanvasWidth/120;
	this.points = view.points;
	this.redoStack = view.redoStack;
	this.main.style.visibility = 'visible';
	
	this.activeCanvasView = view;
	fitPosition();
	drawMiniMap();
}
function generateViewsCanvas() {
	var html = '';
	for ( var i = 0; i < canvasViews.length; i++) {
		html += [
				'<canvas id="'
						+ canvasViews[i].id
						+ '" width="'
						+ this.origCanvasWidth
						+ '" height="'
						+ this.origCanvasHeight
						+ '" class="animClass" style="position:absolute; visibility:hidden; background: #FFFFFF">',
				"Your browser doesn't support HTML5 canvas.", '</canvas>' ]
				.join();
	}
	return html;
}
function transformActiveCanvasView(xTransform, yTransform, scaleTransform) {
	this.main.style.webkitTransform = "translate3d(" + xTransform + "px, " + yTransform + "px, 0px) scale(" + scaleTransform + ")";
	this.overlayElement.style.webkitTransform = "translate3d(" + xTransform + "px, " + yTransform + "px, 0px) scale(" + scaleTransform + ")";
}
function fitPosition() {
	var viewPosition = this.main.style.webkitTransform;
	this.overlayElement.style.webkitTransform = viewPosition;
	curScale = this.activeCanvasView.curS;
	curX = this.activeCanvasView.curX;
	curY = this.activeCanvasView.curY;
	previousScale = this.activeCanvasView.previousS;
	previousXTranslate = this.activeCanvasView.previousX;
	previousYTranslate = this.activeCanvasView.previousY;
	if (moveNavigation) {
		if (curScale == 1) {
			moveNavigation.setVisible(false);
		} else {
			moveNavigation.setVisible(true);
		}
	}
}
function refreshMiniMapPosition() {
	clearCanvas(this.viewSwitcherOverlay);
	drawMiniMap();
}
function drawMiniMap() {
	var miniMapPageX = offsetLeft + totalFreeSpace/2; 
	var miniMapPageY = offsetTop; 
	
	var miniMapX = getCurrentCanvasX(miniMapPageX) + 2;
	var miniMapY = getCurrentCanvasY(miniMapPageY) + 2;
	var miniMapWidth = overlay.width / curScale -4;
	var miniMapHeight = overlay.height / curScale -6;
	
	this.viewSwitcherOverlayContext.strokeRect(miniMapX, miniMapY, miniMapWidth, miniMapHeight);
	updateScaleFactorLabel();
}
function screenshotCanvasView(view) {
	var screenshotCanvas = document.createElement('canvas');
	var viewCanvas = document.getElementById(view.id);
	var screenshotContext = screenshotCanvas.getContext('2d');
	var screenshotOverlay = view.image;
	screenshotCanvas.width = this.origCanvasWidth;
	screenshotCanvas.height = this.origCanvasHeight;
	screenshotContext.fillStyle = "#FFF";
	screenshotContext.fillRect (0,0,this.origCanvasWidth,this.origCanvasHeight);
	if (viewCanvas) {
		screenshotContext.drawImage(viewCanvas, 0, 0);
	}
	screenshotContext.drawImage(screenshotOverlay, 0, 0);
	return screenshotCanvas.toDataURL("image/png");
}
function updateScaleFactorLabel() {
	var scaleFactor = 100 * curScale;
	document.getElementById('scaleFactorLabel').innerHTML = "Zoom: " + scaleFactor.toFixed() + "%";
}
var intensityLabel;
var color;
var drawingStartTime;
var multiTouchTimeRange;
var activeColorButtonNr;
var zoomNavigation;
var moveNavigation;
function initializeDrawing() {
	createCanvasViews();
}
function startDrawing() {
	initVariables();
	createGUI();
	initGUI();
	registerListeners();
	setActiveView(canvasViews[0]);
	activateColorButton(firstActivatedColorButton);
}
function stopDrawing() {
	unregisterListeners();
	
	activeColorButtonNr = 0;
	tmpColorButtonNr = 0;
	
	if (Ext.get('intensity-label')) {
		Ext.get('intensity-label').destroy();    		
	}
	if (intensityLabel) intensityLabel.destroy();
	intensityLabel = null;
	
}
function initVariables() {
	
	
	viewSwitcherSpots = canvasViews.length;
	initScale = 1;
	initialTranslationY = 0;
	initialTranslationX = 0;
	viewSwitcherInitialTranslationX = 0;
	viewSwitcherInitialTranslationY = 0;
	activeColorButtonNr = 0;
	previousScale = 1;
	curScale = 0;
	startX = 0;
	startY = 0;
	previousXTranslate = 0;
	previousYTranslate = 0;
	curX = 0;
	curY = 0;
	drawingStartTime = 0;
	isZooming = false;
	isDrawingBlocked = false;
	multiTouchTimeRange = 500;
	brushWidth = 25;
}
function drawCallback(x, y, dragging) {	
	
	if (!isZooming) {
		var point = new Object();
		point.x = x;
		point.y = y;
		point.dragging = dragging;
		point.color = color;
		point.lineWidth = brushWidth/(initScale*previousScale);
		
		points.push(point);
		drawPointOnCanvas(context);
		if (viewSwitcherContext) drawPointOnCanvas(viewSwitcherContext);
	}
}
function convertPointsToString(strPoints) {
	var str = '';
	
	for (var i = 0; i < strPoints.length; i++) {
		str += strPoints[i].x.toFixed() + "," + strPoints[i].y.toFixed() + "," + strPoints[i].dragging + "," + strPoints[i].color + "," + strPoints[i].lineWidth.toFixed() + ";";
	}
	return str;
}
function convertStringToPoints(string) {
	var tmpPointValues;
	var points = new Array();	
	
	if (string && string != '') {
		var pointsStringArray = string.split(";");
		
		for (var i = 0; i < pointsStringArray.length-1; i++) { //length -1 because the last element is empty cause of the ";" at the end while splitting
			tmpPointValues = pointsStringArray[i].split(',');
			
			var point = new Object();
			point.x = parseInt(tmpPointValues[0]);
			point.y = parseInt(tmpPointValues[1]);
			point.dragging = myParseBool(tmpPointValues[2]);
			point.color = tmpPointValues[3];
			point.lineWidth = parseInt(tmpPointValues[4]);
			points.push(point);
		}
	}
	
	return points;
}
function somePointsDrawn() {
	for (var i = 0; i < canvasViews.length; i++) {
		if (canvasViews[i].points.length > 0) {
			return true;
		}
	}
	return false;
}
function myParseBool(string) {
	if (string == 'true') {
		return true;
	} else if (string == 'false') {
		return false;
	} 
	return null;
}
function clearCanvas(canvas) {
	var context = canvas.getContext('2d');
	var tmpFillStyle = context.fillStyle;
	var tmpLineJoin = context.lineJoin;
	var tmpLineCap = context.lineCap;
	var tmpStrokeStyle = context.strokeStyle;
	var tmpLineWidth = context.lineWidth;
	
	canvas.width = canvas.width;
	canvas.height = canvas.height;
	
	context.fillStyle = tmpFillStyle;
	context.lineJoin = tmpLineJoin;
	context.lineCap = tmpLineCap;
	context.strokeStyle = tmpStrokeStyle;
	context.lineWidth = tmpLineWidth;
}
function drawPointOnCanvas(canvasContext) {
	var i = points.length - 1;
	canvasContext.strokeStyle = points[i].color;
	canvasContext.lineWidth = points[i].lineWidth;
	canvasContext.beginPath();
	if (points[i].dragging && i) {
		canvasContext.moveTo(points[i - 1].x, points[i - 1].y);
	} else {
		canvasContext.moveTo(points[i].x - 1, points[i].y);
		this.redoStack = new Array();
	}
	canvasContext.lineTo(points[i].x, points[i].y);
	canvasContext.moveTo(points[i].x, points[i].y);
	canvasContext.closePath();
	canvasContext.stroke();
}
function redraw() {
	redrawCanvas(main);
	if (viewSwitcherMain) redrawCanvas(viewSwitcherMain);
}
function redrawCanvas(canvas) {
	clearCanvas(canvas);
	var canvasContext = canvas.getContext('2d');
	
	for ( var i = 0; i < points.length; i++) {
		canvasContext.strokeStyle = points[i].color;
		canvasContext.lineWidth = points[i].lineWidth;
		canvasContext.beginPath();
		if (points[i].dragging && i) {
			canvasContext.moveTo(points[i - 1].x, points[i - 1].y);
		} else {
			canvasContext.moveTo(points[i].x - 1, points[i].y);
		}
		canvasContext.lineTo(points[i].x, points[i].y);
		canvasContext.moveTo(points[i].x, points[i].y);
		canvasContext.closePath();
		canvasContext.stroke();
	}
}
function drawExistingDrawingRecords(recs) {
	var firstImageToRedraw = null;
	var sizeFactor = 1;
	
	for (var i = 0; i < recs.length; i++) {
		if (recs[i] && recs[i].data.screenshot && recs[i].data.screenshot != 'NA') {
			firstImageToRedraw = recs[i].data.screenshot;
			break;
		}
	}
	if (firstImageToRedraw) {
		var tmpImage = new Image();
		tmpImage.onload = function() {
			sizeFactor = origCanvasWidth / tmpImage.width;
			if (origCanvasHeight/tmpImage.height != sizeFactor) {
			}
	
			for (var i in recs) {
				var data = recs[i].data;
		
				if (data.points) {
					var canvasView = getCanvasViewFromId(data.canvasView);
					canvasView.points = convertStringToPoints(data.points);
					
					if (sizeFactor != 1) {
						for (var j in canvasView.points) {
							canvasView.points[j].x *= sizeFactor;
							canvasView.points[j].y *= sizeFactor;
							canvasView.points[j].lineWidth *= sizeFactor;
						}
					}
					
					if (i == 0) { //if it is the first view, only activate it
						setActiveView(canvasView);	
					} else { //switch the views if it is one of the following views
						switchViewTo(canvasView);
					}
					
					redraw();
				}
			}
			
			if (activeCanvasView && activeCanvasView != canvasViews[0]) {
				switchViewTo(canvasViews[0]);
			} else {
				setActiveView(canvasViews[0]);
			}
		};
		
		tmpImage.src = firstImageToRedraw;
	}
}
function clearLastDrawing() {
	if (this.points.length > 0) {
		var lastIndex = this.points.length - 1;
		while (lastIndex > 0 && this.points[lastIndex].dragging) {
			this.points.pop();
			lastIndex--;
		}
		if (lastIndex >= 0) {
			this.points.pop();
		}
		redraw();
	}
}
function undoDrawing() {
	if (this.points.length > 0) {
		var lastIndex = this.points.length - 1;
		while (lastIndex > 0 && this.points[lastIndex].dragging) {
			this.redoStack.push(this.points.pop());
			lastIndex--;
		}
		if (lastIndex >= 0) {
			this.redoStack.push(this.points.pop());
		}
		redraw();
	}
}
function redoDrawing() {
	if (this.redoStack.length > 0) {
		var lastIndex = this.redoStack.length - 1;
		this.points.push(this.redoStack.pop());
		lastIndex--;
		while (lastIndex >= 0 && redoStack[lastIndex].dragging) {
			this.points.push(this.redoStack.pop());
			lastIndex--;
		}
		redraw();
	}
}
function getCanvasX(pageX) {
	
	var x  = pageX/(previousScale*initScale);									//scale x of the page according to previous canvas-scaling
	    x += xcenter - (xcenter + offsetLeft)/(previousScale*initScale);		//adjust x to scaled canvas offsets
	    x -= previousXTranslate/previousScale;									//adjust x to moved/translated canvas-position
	    x -= initialTranslationX/(initScale*previousScale); 					//include the initially side-move-translation
	
	return x; 
}
function getCanvasY(pageY) {
	
	var y  = pageY/(previousScale*initScale);									//scale y of the page according to previous canvas-scaling
	    y += ycenter - (ycenter + offsetTop)/(previousScale*initScale);			//adjust y to scaled canvas offsets
	    y -= previousYTranslate/previousScale;									//adjust y to moved/translated canvas-position
	    y -= initialTranslationY/(initScale*previousScale);						//include the initially down-move-translation
	
	return y;
}
function getCurrentCanvasX(pageX) {
	
	var x  = pageX/(curScale*initScale);								//scale x of the page according to previous canvas-scaling
	    x += xcenter - (xcenter + offsetLeft)/(curScale*initScale);		//adjust x to scaled canvas offsets
	    x -= curX/curScale;												//adjust x to moved/translated canvas-position
	    x -= initialTranslationX/(initScale*curScale); 					//include the initially side-move-translation
	
	return x; 
}
function getCurrentCanvasY(pageY) {
	
	var y  = pageY/(curScale*initScale);									//scale y of the page according to previous canvas-scaling
	    y += ycenter - (ycenter + offsetTop)/(curScale*initScale);			//adjust y to scaled canvas offsets
	    y -= curY/curScale;													//adjust y to moved/translated canvas-position
	    y -= initialTranslationY/(initScale*curScale);						//include the initially down-move-translation
	
	return y;
}
function keepCanvasInContainer() {
	
	var leftTopX = curX - (main.width * curScale - main.width ) / 2;
	var leftTopY = curY - (main.height * curScale - main.height ) / 2;
	var rightBottomX = leftTopX + main.width * curScale ;
	var rightBottomY = leftTopY + main.height * curScale ;
	
	if (leftTopX > 0) {
		curX = (main.width  * curScale - main.width ) / 2;
	}
	if (rightBottomX < main.width ) {
		curX = main.width  + (main.width  * curScale - main.width ) / 2 - main.width * curScale;
	}
	if (leftTopY > 0) {
		curY = (main.height  * curScale - main.height ) / 2;
	}
	if (rightBottomY < main.height ) {
		curY = main.height  + (main.height  * curScale - main.height ) / 2 - main.height * curScale ;
	} 
}
function validateCurScale() {
	if (curScale < 1) {
		curScale = 1;
	} else if (curScale > 8) {
		curScale = 8;
	}
}
function touchStart(e) {
  	if (!isDrawingBlocked && !isZooming && e.touches.length == 1) { 
  		
	  	var x = getCanvasX(e.pageX);                
	  	var y = getCanvasY(e.pageY);
  		
  		drawingStartTime = new Date().getTime();
  		drawCallback(x, y, false);
  	}
}
function touchMove(e) {
	
	var x = getCanvasX(e.pageX);                
	var y = getCanvasY(e.pageY);
	
  	if (!isDrawingBlocked && !isZooming && e.touches.length == 1 && (x > brushWidth/2 && x < origCanvasWidth - brushWidth/2) && (y > brushWidth/2 && y < origCanvasHeight - brushWidth/2)) {
  	  	drawCallback(x, y, true);
  	}
}
function touchEnd(e) {}
function gestureStart(e) {
	
  	var x = getCanvasX(e.pageX);                
  	var y = getCanvasY(e.pageY);
  
  	isZooming = true;
	
	if (new Date().getTime() - drawingStartTime < multiTouchTimeRange) {
		clearLastDrawing();
	}
	
	startX = x;
	startY = y;
}
function gestureChange(e) {
	
  	var x = getCanvasX(e.pageX);                
  	var y = getCanvasY(e.pageY);
  
	curX = (x - startX)*previousScale + previousXTranslate;
	curY = (y - startY)*previousScale + previousYTranslate;
	curScale = previousScale * e.scale;
	validateCurScale();
	
	curX = curX - ((xcenter - startX)*previousScale - (xcenter - startX)*curScale);
	curY = curY - ((ycenter - startY)*previousScale - (ycenter - startY)*curScale); 
	
	keepCanvasInContainer();
	
	transformActiveCanvasView(curX, curY, curScale);
	
	refreshMiniMapPosition();
}
function gestureEnd(e) {
	isZooming = false;
	
    previousScale = curScale; 
	previousXTranslate = curX;
	previousYTranslate = curY;
	
	Ext.Viewport.fireEvent('gestureEnd');
}
var origCanvasWidth = 588; 	//1x:588 1.5x: 882 2x:1176 in px
var origCanvasHeight = 640;
var frontMaleImgPath = 'drawing/templates/front-male.png';
var backMaleImgPath = 'drawing/templates/back-male.png';
var leftMaleImgPath = 'drawing/templates/left-male.png';
var rightMaleImgPath = 'drawing/templates/right-male.png';
var frontFemaleImgPath = 'drawing/templates/front-female.png';
var backFemaleImgPath = 'drawing/templates/back-female.png';
var leftFemaleImgPath = 'drawing/templates/left-female.png';
var rightFemaleImgPath = 'drawing/templates/right-female.png';
	
	
function canvasViewSwitcherItems() {
	var items = new Array();
	var tempViewId;
	
	if (clientIdentifier.indexOf('large-android') > -1) {
		for (var i = 0; i < canvasViews.length; i++) {
			tempViewId = canvasViews[i].id;
			items[i] = {
		   		  html: ['<div id="' + tempViewId + '_switcher_canvas_container" class="canvasViewSwitcher" style="width:'+ (this.scaledWidth/viewSwitcherSpots) +'px; height:'+(this.scaledHeight/viewSwitcherSpots)+'px;">',
		   		         '<div id="' + tempViewId + '_switcher_android_scale_container" style="width:'+ this.origCanvasWidth +'px; height:'+this.origCanvasHeight+'px;">',
		   		         '<canvas id="' + tempViewId + '_switcher" width="'+ this.origCanvasWidth +'" height="'+ this.origCanvasHeight +'" style="position:absolute; background: white;">',
		   		         	"Your browser doesn't support HTML5 canvas.",
		   		         '</canvas>',
		   		         '<canvas id="' + tempViewId + '_switcher_overlay" width="'+ this.origCanvasWidth +'" height="'+ this.origCanvasHeight +'" style="position:absolute; background: url(' + canvasViews[i].image.src + ')">',
		   		         	"Your browser doesn't support HTML5 canvas.",
		   		         '</canvas></div></div>'].join("")
			};
		}
	} else {
		for (var i = 0; i < canvasViews.length; i++) {
			tempViewId = canvasViews[i].id;
			items[i] = {
				  html: ['<div id="' + tempViewId + '_switcher_canvas_container" class="canvasViewSwitcher" style="width:'+(this.scaledWidth/this.viewSwitcherSpots)+'px; height:'+(this.scaledHeight/this.viewSwitcherSpots)+'px;">',
		   		         '<canvas id="' + tempViewId + '_switcher" width="'+ this.origCanvasWidth +'" height="'+ this.origCanvasHeight +'" style="position:absolute; background: white;">',
		   		         	"Your browser doesn't support HTML5 canvas.",
		   		         '</canvas>',
		   		         '<canvas id="' + tempViewId + '_switcher_overlay" width="'+ this.origCanvasWidth +'" height="'+ this.origCanvasHeight +'" style="position:absolute; background: url(' + canvasViews[i].image.src + ')">',
		   		         	"Your browser doesn't support HTML5 canvas.",
		   		         '</canvas></div>'].join("")
			};
		}
	}
	return items;
}
function initGUI() {
	overlay = document.getElementById('overlay');
	overlayContext = overlay.getContext('2d');
	
	xcenter = overlay.width/2;
	ycenter = overlay.height/2;
	
	offsetLeft = svSidebar.element.dom.clientWidth + Ext.get('new-wizard-menu-panel').getWidth() + Ext.get('new-wizard-content-panel').getMargin().left + Ext.get('new-wizard-content-panel').dom.clientLeft; 
	offsetTop = getAllActiveTopToolbarsHeight() + Ext.get('new-wizard-content-panel').getMargin().top + Ext.get('new-wizard-content-panel').dom.clientTop; 
	
	document.getElementById('canvas_container').style.webkitTransform =  "translate3d(" + this.initialTranslationX + "px, " + this.initialTranslationY + "px, 0px) scale(" + this.initScale + ")";
	if (clientIdentifier.indexOf('large-android') > -1) {
		for (var i = 0; i < canvasViews.length; i++) {  
			document.getElementById(canvasViews[i].id + '_switcher_android_scale_container').style.webkitTransform = "translate3d(" + viewSwitcherInitialTranslationX + "px, " + viewSwitcherInitialTranslationY + "px, 0px) scale(" + initScale/viewSwitcherSpots + ")";
		}
	} else {
		for (var i = 0; i < canvasViews.length; i++) {
			document.getElementById(canvasViews[i].id + '_switcher').style.webkitTransform =  "translate3d(" + this.viewSwitcherInitialTranslationX + "px, " + this.viewSwitcherInitialTranslationY + "px, 0px) scale(" + this.initScale/this.viewSwitcherSpots + ")";
			document.getElementById(canvasViews[i].id + '_switcher_overlay').style.webkitTransform =  "translate3d(" + this.viewSwitcherInitialTranslationX + "px, " + this.viewSwitcherInitialTranslationY + "px, 0px) scale(" + this.initScale/this.viewSwitcherSpots + ")";
		}
	}
}
function registerListeners() {		
	 
	 if (clientIdentifier.indexOf('large-android') > -1) registerAndroidListeners();
	 else registerIosListeners();
	 
	 for (var i = 0; i < canvasViews.length; i++) { 
		 Ext.get(canvasViews[i].id + '_switcher_overlay').on({
			 
			 touchstart: canvasViews[i].callback = function() {
    			  
	     			var callingViewId = this.id.substr(0, (this.id.length - 17));
	     			var newView = getCanvasViewFromId(callingViewId);
	     			
	     			if (newView.id != this.activeCanvasViewId) {
	         	    	switchViewTo(newView); 
	     				}
	     			} 
		 });
	 }
}
function unregisterListeners() {		
	 if (clientIdentifier.indexOf('large-android') > -1) {
		 unregisterAndroidListeners();
	 } else {
		 unregisterIosListeners();
	 }
	 
	 for (var i = 0; i < canvasViews.length; i++) { 
		 Ext.get(canvasViews[i].id + '_switcher_overlay').removeListener('touchstart', canvasViews[i].callback); 
	 }
}
function registerIosListeners() {
	 Ext.get('overlay').on({
		 touchstart: touchStart,
		 touchmove: touchMove,
		 touchend: touchEnd
	 });
	 
	 overlay.addEventListener("gesturestart", gestureStart, false);
	 overlay.addEventListener("gesturechange", gestureChange, false);
	 overlay.addEventListener("gestureend", gestureEnd, false);
}
function registerAndroidListeners() {
	 Ext.get('overlay').on({
		 touchstart: touchStart,
		 touchmove: touchMove,
		 touchend: touchEnd,
		 pinchstart: gestureStart,
		 pinch: gestureChange,
		 pinchend: gestureEnd
	 });
}
function unregisterIosListeners() {
	Ext.get('overlay').removeListener('touchstart', touchStart);
	Ext.get('overlay').removeListener('touchmove', touchMove);
	Ext.get('overlay').removeListener('touchend', touchEnd);
	
	overlay.removeEventListener("gesturestart", gestureStart, false);
	overlay.removeEventListener("gesturechange", gestureChange, false);
	overlay.removeEventListener("gestureend", gestureEnd, false);
}
function unregisterAndroidListeners() {
	Ext.get('overlay').removeListener('touchstart', touchStart);
	Ext.get('overlay').removeListener('touchmove', touchMove);
	Ext.get('overlay').removeListener('touchend', touchEnd);
	
	overlay.removeEventListener('pinchstart', gestureStart, false);
	overlay.removeEventListener('pinch', gestureChange, false);
	overlay.removeEventListener('pinchend', gestureEnd, false);
}